use buzz_in::BuzzIn;
use register::Register;
use serde::{Deserialize, Serialize};

pub mod buzz_in;
pub mod register;

#[derive(Debug, Serialize, Clone)]
#[serde(tag = "type")]
pub enum ClientMessage {
    BuzzIn(BuzzIn),
    Register(Register),
    CreateRoom(Register),
    ResetBuzzers,
}

#[derive(Debug, Serialize)]
pub struct ClientRequest {
    pub token: String,
    pub msg: ClientMessage,
}

#[derive(Debug, Deserialize)]
#[serde(tag = "type")]
pub enum GameResponse {
    JoinResponse { username: String, token: String },
    HostResponse { username: String, token: String },
    AckBuzzer,
    ResetBuzzer,
    UpdatePointTotal { score: i32 },
}
